// Connections
sbit LED   at LATA4_bit;  // Dahili LED RA4 Pinine Bagli
sbit SERVO at LATB0_bit;  // Servo Motor B0 Pinine Bagli

unsigned int adc=0;       // ADC degeri kayit degiskeni
unsigned int degree;      // Ai degeri kayit degiskeni

// 10uS'lik tekrarli zamanlama fonksiyonu
void vdelay_10us(unsigned int time){
  while(time){            // time degeri 0 olmadigi srece dng
    delay_us(10);         // 10us Bekle
    time--;               // time degerini 1 azalt
  }
}

// Herhangi bir araliktaki degeri diger bir araliga donusturme fonksiyonu
long map(long x, long in_min, long in_max, long out_min, long out_max) {
  return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}

void setServoDegree(unsigned int deg){
  unsigned int TON;               // Servonun aktif kalacagi sure

  TON=map(deg, 0, 180, 50, 240);  // Fonksiyon ierisine gelen aci degerini (0-180)
                                  // Servo iin gerekli zaman degerlerine ceviriyoruz (500us-2400us)

  SERVO=1;                        // Servo Aktif
  vdelay_10us(TON);               // Aktif kalacagi sure kadar bekleme
  SERVO=0;                        // Servo Pasif
  vdelay_10us(2000-TON);          // 20ms'lik dongu suresi
}

void main() {
  // Port Giris-ikis Seimi (0:ikis, 1:Giris)
  TRISA=0b00000010;// [][][][LED][][][XY Joystick X][]
  TRISB=0b00000000;// [][][][][][][][SG90]
  TRISC=0b00000000;// [][][][][][][][]
  TRISD=0b00000000;// [][][][][][][][]
  TRISE=0b00000000;// [][][][][][][][]

  // Port Analog-Dijital Giris Seimi (0:Dijital, 1:Analog)
  ANSELA=0b00000010;// [][][][][][][ADC][]
  ANSELB=0b00000000;// [][][][][][][][]
  ANSELC=0b00000000;// [][][][][][][][]
  ANSELD=0b00000000;// [][][][][][][][]
  ANSELE=0b00000000;// [][][][][][][][]

  // Port Temizleme
  LATA=0x00;
  LATB=0x00;
  LATC=0x00;
  LATD=0x00;
  LATE=0x00;

  // Sonsuz Dongu
  while(1){
    adc=ADC_Read(1);                     // ADC degerini oku
    degree=map(adc, 0, 1023, 0, 180);    // Okunan degeri (0-1023) dereceye cevir (0-180)

    setServoDegree(degree);              // Ollen derece degerini setServoDegree fonksiyonuna gonder
  }
}